import os
import ConfigParser
from traceback import format_exc
import sys

class CustomerConfigException (Exception):
      def __init__(self, value):
            self.value = value

      def __str__(self):
            return repr(self.value)

class CustomerConfig:
      def __init__(self, configFile, infra, language = 'en', section = ''):
            self.configFile = configFile
            self.language   = 'en' #language
            self.section    = section
            self.configParser     = ConfigParser.ConfigParser()
            self.configParser.read(configFile)

            self.infra      = infra
            self.logging    = infra.getLoggingInstance()
            self.logger     = self.logging.getLogger('meresco.configs')

            self.logger.debug('Init for customerConfig, file: '+ configFile)
#            self.logging.debug('Init for customerConfig, file: '+ configFile)

      def setDefaults(self, section, language = 'en'):
            self.section = section
            self.language= 'en'

      def setSection(self, section):
            self.section = section

      def getConfig(self):
            return self.configParser

      def setLanguage(self, language):
            self.language = 'en'

      def setSubst(self, substDict):
            self.substDict = substDict

      def get(self, option, default = '', section = '',substDict={}):
            lanOption=option
            config  = self.configParser
            logger  = self.logger
            sane = True
            value =''

            if (substDict == ''): substDict=self.substDict
            if (section == ''): section = self.section

            if (option == None or section == ''):
                  logger.error("No valid option,section combination specified")
                  sane = False

            if (section == None or section == '') :
                  logger.error("No section specified")
                  sane = False

            if (default != ''):
                  value = default
            elif option != '':
                  value = option

            if (sane):
                  try:
                        value = config.get(section, lanOption, 0, substDict)
                  except:
                        self.logger.debug (format_exc())
                        try:
                              value = config.get(section, option, 0, substDict)
                        except Exception, e:
                              self.logger.debug (format_exc())
                              logger.warning ('"' + option + '[_' + self.language + ']'  +
                                              '" NOT specified ' + 'in file: "' +
                                              self.configFile + '" section: "' + section + '". Using default value: ' + default)

            else:
                   CustomerConfigException("Incomplete request")

            logger.debug('returning value: [' + value +']')
            return value

      def dump(self):
            s = ''
            for section in config.sections():
                  s = s + ("section: " +  section )
                  for option in config.options(section):
                        s = s + " " + option + "=" + config.get(section, option) + "\n"
            return s




